/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : CAN1.c
**     Project     : ProcessorExpert
**     Processor   : MK20DX256VLQ10
**     Component   : Init_CAN
**     Version     : Component 01.008, Driver 01.08, CPU db: 3.00.000
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2021-06-04, 17:56, # CodeGen: 1071
**     Abstract    :
**          This file implements the CAN (CAN0) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
**     Settings    :
**          Component name                                 : CAN1
**          Device                                         : CAN0
**          Settings                                       : 
**            Clock gate                                   : Enabled
**            Clock settings                               : 
**              Clock divisor select value                 : 11
**              Phase segment 1                            : 4
**              Phase segment 2                            : 3
**              Propagation segment                        : 8
**              CAN clock source                           : Internal bus clock
**              CAN frequency                              : 250 kHz
**              Resync jump width                          : 3
**              Free-running timer                         : 0
**            Timer synchronize mode                       : Disabled
**            Lowest buffer transmitted first              : Buffer with highest priority is transmitted first
**            Freeze mode                                  : Enabled
**            Samples per bit                              : One sample
**            Bus off recovery mode                        : Enabled
**            Loop back mode                               : Disabled
**            Listen only mode                             : Disabled
**            Abort                                        : Disabled
**            Wake-up                                      : Disabled
**            Wake-up source filtered                      : no
**            Rx FIFO                                      : Disabled
**            Supervisor mode                              : yes
**            Write-Access to memory in Freeze mode        : Enabled
**            Self reception disable                       : yes
**            Local priority                               : Enabled
**            ID Acceptance Mode                           : Format A
**            Mailboxes reception priority                 : from Mailboxes to Rx FIFO
**            Remote Request Storing                       : Disabled
**            Entire Frame Arbitration Field Comparison for Rx Mailboxes : Disabled
**            Tx Arbitration Start Delay                   : 9
**            Number of the Last Message Buffer            : 15
**            Individual Rx Masking and Queue              : Enabled
**            Rx FIFO global data mask                     : FFFFFFFF
**            Rx Individual MB data mask                   : 
**              Mailbox 0 data mask                        : FFFFFFFF
**              Mailbox 1 data mask                        : FFFFFFFF
**              Mailbox 2 data mask                        : FFFFFFFF
**              Mailbox 3 data mask                        : FFFFFFFF
**              Mailbox 4 data mask                        : FFFFFFFF
**              Mailbox 5 data mask                        : FFFFFFFF
**              Mailbox 6 data mask                        : FFFFFFFF
**              Mailbox 7 data mask                        : FFFFFFFF
**              Mailbox 8 data mask                        : FFFFFFFF
**              Mailbox 9 data mask                        : FFFFFFFF
**              Mailbox 10 data mask                       : FFFFFFFF
**              Mailbox 11 data mask                       : FFFFFFFF
**              Mailbox 12 data mask                       : FFFFFFFF
**              Mailbox 13 data mask                       : FFFFFFFF
**              Mailbox 14 data mask                       : FFFFFFFF
**              Mailbox 15 data mask                       : FFFFFFFF
**            Global data mask                             : FFFFFFFF
**            Data buffer 14 mask                          : FFFFFFFF
**            Data buffer 15 mask                          : FFFFFFFF
**            Number of Rx FIFO filters                    : 8
**          Pins                                           : 
**            Receiver pin                                 : Enabled
**              Pin                                        : TSI0_CH12/PTB19/CAN0_RX/FTM2_CH1/I2S0_TX_FS/FB_OE_b/FTM2_QD_PHB
**              Pin signal                                 : CAN1_RX
**            Transmitter pin                              : Enabled
**              Pin                                        : TSI0_CH11/PTB18/CAN0_TX/FTM2_CH0/I2S0_TX_BCLK/FB_AD15/FTM2_QD_PHA
**              Pin signal                                 : CAN1_TX
**          Interrupts                                     : 
**            MB logical OR interrupt                      : 
**              Interrupt                                  : INT_CAN0_ORed_Message_buffer
**              Interrupt request                          : Disabled
**              Interrupt priority                         : 0 (Highest)
**              ISR name                                   : CAN1_PowerTxDone_Int
**              Message buffer 0 interrupt                 : Disabled
**              Message buffer 1 interrupt                 : Disabled
**              Message buffer 2 interrupt                 : Disabled
**              Message buffer 3 interrupt                 : Disabled
**              Message buffer 4 interrupt                 : Disabled
**              Message buffer 5 interrupt                 : Disabled
**              Message buffer 6 interrupt                 : Disabled
**              Message buffer 7 interrupt                 : Disabled
**              Message buffer 8 interrupt                 : Disabled
**              Message buffer 9 interrupt                 : Disabled
**              Message buffer 10 interrupt                : Disabled
**              Message buffer 11 interrupt                : Disabled
**              Message buffer 12 interrupt                : Disabled
**              Message buffer 13 interrupt                : Disabled
**              Message buffer 14 interrupt                : Disabled
**              Message buffer 15 interrupt                : Disabled
**            Bus-off interrupt                            : 
**              Interrupt                                  : INT_CAN0_Bus_Off
**              Interrupt request                          : Disabled
**              Interrupt priority                         : 0 (Highest)
**              ISR name                                   : 
**              Bus-off interrupt                          : Disabled
**            Error interrupt                              : 
**              Interrupt                                  : INT_CAN0_Error
**              Interrupt request                          : Disabled
**              Interrupt priority                         : 0 (Highest)
**              ISR name                                   : 
**              Error interrupt                            : Disabled
**            Warning interrupt                            : Disabled
**            Wakeup interrupt                             : 
**              Interrupt                                  : INT_CAN0_Wake_Up
**              Interrupt request                          : Disabled
**              Interrupt priority                         : 0 (Highest)
**              ISR name                                   : 
**              Wakeup interrupt                           : Disabled
**          Initialization                                 : 
**            Module enable                                : yes
**            Keep in Freeze/Halt                          : yes
**            Call Init method                             : yes
**     Contents    :
**         Init - void CAN1_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file CAN1.c
** @version 01.08
** @brief
**          This file implements the CAN (CAN0) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
*/         
/*!
**  @addtogroup CAN1_module CAN1 module documentation
**  @{
*/         

/* MODULE CAN1. */

#include "CAN1.h"
  /* Including shared modules, which are used in the whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Cpu.h"


/*
** ===================================================================
**     Method      :  CAN1_Init (component Init_CAN)
**     Description :
**         This method initializes registers of the CAN module
**         according to the Peripheral Initialization settings.
**         Call this method in user code to initialize the module. By
**         default, the method is called by PE automatically; see "Call
**         Init method" property of the component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void CAN1_Init(void)
{
  /* SIM_SCGC6: FLEXCAN0=1 */
  SIM_SCGC6 |= SIM_SCGC6_FLEXCAN0_MASK;
  /* CAN0_MCR: MDIS=1 */
  CAN0_MCR |= CAN_MCR_MDIS_MASK;
  /* CAN0_TIMER: TIMER=0 */
  CAN0_TIMER &= (uint32_t)~(uint32_t)(CAN_TIMER_TIMER(0xFFFF));
  /* CAN0_CTRL1: CLKSRC=1 */
  CAN0_CTRL1 |= CAN_CTRL1_CLKSRC_MASK;
  /* CAN0_MCR: MDIS=0,SOFTRST=1 */
  CAN0_MCR = (uint32_t)((CAN0_MCR & (uint32_t)~(uint32_t)(
              CAN_MCR_MDIS_MASK
             )) | (uint32_t)(
              CAN_MCR_SOFTRST_MASK
             ));
  while(!(CAN0_MCR & CAN_MCR_FRZACK_MASK)){} /* Wait for entering the freeze mode */
  /* CAN0_MCR: RFEN=0,SUPV=1,SLFWAK=0,WAKSRC=0,SRXDIS=1,IRMQ=1,LPRIOEN=1,AEN=0,IDAM=0 */
  CAN0_MCR = (uint32_t)((CAN0_MCR & (uint32_t)~(uint32_t)(
              CAN_MCR_RFEN_MASK |
              CAN_MCR_SLFWAK_MASK |
              CAN_MCR_WAKSRC_MASK |
              CAN_MCR_AEN_MASK |
              CAN_MCR_IDAM(0x03)
             )) | (uint32_t)(
              CAN_MCR_SUPV_MASK |
              CAN_MCR_SRXDIS_MASK |
              CAN_MCR_IRMQ_MASK |
              CAN_MCR_LPRIOEN_MASK
             ));
  /* CAN0_CTRL1: PRESDIV=0x0B,RJW=2,PSEG1=3,PSEG2=2,LPB=0,SMP=0,BOFFREC=0,TSYN=0,LBUF=0,LOM=0,PROPSEG=7 */
  CAN0_CTRL1 = (uint32_t)((CAN0_CTRL1 & (uint32_t)~(uint32_t)(
                CAN_CTRL1_PRESDIV(0xF4) |
                CAN_CTRL1_RJW(0x01) |
                CAN_CTRL1_PSEG1(0x04) |
                CAN_CTRL1_PSEG2(0x05) |
                CAN_CTRL1_LPB_MASK |
                CAN_CTRL1_SMP_MASK |
                CAN_CTRL1_BOFFREC_MASK |
                CAN_CTRL1_TSYN_MASK |
                CAN_CTRL1_LBUF_MASK |
                CAN_CTRL1_LOM_MASK
               )) | (uint32_t)(
                CAN_CTRL1_PRESDIV(0x0B) |
                CAN_CTRL1_RJW(0x02) |
                CAN_CTRL1_PSEG1(0x03) |
                CAN_CTRL1_PSEG2(0x02) |
                CAN_CTRL1_PROPSEG(0x07)
               ));
  /* CAN0_CTRL2: WRMFRZ=1,RFFN=0,TASD=9,MRP=1,RRS=0,EACEN=0 */
  CAN0_CTRL2 = (uint32_t)((CAN0_CTRL2 & (uint32_t)~(uint32_t)(
                CAN_CTRL2_RFFN(0x0F) |
                CAN_CTRL2_TASD(0x16) |
                CAN_CTRL2_RRS_MASK |
                CAN_CTRL2_EACEN_MASK
               )) | (uint32_t)(
                CAN_CTRL2_WRMFRZ_MASK |
                CAN_CTRL2_TASD(0x09) |
                CAN_CTRL2_MRP_MASK
               ));
  /* CAN0_RXMGMASK: MG=0xFFFFFFFF */
  CAN0_RXMGMASK = CAN_RXMGMASK_MG(0xFFFFFFFF);
  /* CAN0_RX14MASK: RX14M=0xFFFFFFFF */
  CAN0_RX14MASK = CAN_RX14MASK_RX14M(0xFFFFFFFF);
  /* CAN0_RX15MASK: RX15M=0xFFFFFFFF */
  CAN0_RX15MASK = CAN_RX15MASK_RX15M(0xFFFFFFFF);
  /* CAN0_RXFGMASK: FGM=0xFFFFFFFF */
  CAN0_RXFGMASK = CAN_RXFGMASK_FGM(0xFFFFFFFF);
  /* CAN0_RXIMR0: MI=0xFFFFFFFF */
  CAN0_RXIMR0 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR1: MI=0xFFFFFFFF */
  CAN0_RXIMR1 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR2: MI=0xFFFFFFFF */
  CAN0_RXIMR2 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR3: MI=0xFFFFFFFF */
  CAN0_RXIMR3 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR4: MI=0xFFFFFFFF */
  CAN0_RXIMR4 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR5: MI=0xFFFFFFFF */
  CAN0_RXIMR5 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR6: MI=0xFFFFFFFF */
  CAN0_RXIMR6 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR7: MI=0xFFFFFFFF */
  CAN0_RXIMR7 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR8: MI=0xFFFFFFFF */
  CAN0_RXIMR8 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR9: MI=0xFFFFFFFF */
  CAN0_RXIMR9 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR10: MI=0xFFFFFFFF */
  CAN0_RXIMR10 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR11: MI=0xFFFFFFFF */
  CAN0_RXIMR11 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR12: MI=0xFFFFFFFF */
  CAN0_RXIMR12 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR13: MI=0xFFFFFFFF */
  CAN0_RXIMR13 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR14: MI=0xFFFFFFFF */
  CAN0_RXIMR14 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_RXIMR15: MI=0xFFFFFFFF */
  CAN0_RXIMR15 = CAN_RXIMR_MI(0xFFFFFFFF);
  /* CAN0_ESR1: TWRNINT=1,RWRNINT=1,BOFFINT=1,ERRINT=1,WAKINT=1 */
  CAN0_ESR1 |= CAN_ESR1_TWRNINT_MASK |
               CAN_ESR1_RWRNINT_MASK |
               CAN_ESR1_BOFFINT_MASK |
               CAN_ESR1_ERRINT_MASK |
               CAN_ESR1_WAKINT_MASK;
  /* CAN0_IFLAG1: BUF31TO8I=0x00FFFFFF,BUF7I=1,BUF6I=1,BUF5I=1,BUF4TO0I=0x1F */
  CAN0_IFLAG1 = CAN_IFLAG1_BUF31TO8I(0x00FFFFFF) |
                CAN_IFLAG1_BUF7I_MASK |
                CAN_IFLAG1_BUF6I_MASK |
                CAN_IFLAG1_BUF5I_MASK |
                CAN_IFLAG1_BUF4TO0I(0x1F);
  /* CAN0_MCR: WAKMSK=0,WRNEN=0 */
  CAN0_MCR &= (uint32_t)~(uint32_t)((CAN_MCR_WAKMSK_MASK | CAN_MCR_WRNEN_MASK));
  /* CAN0_CTRL1: BOFFMSK=0,ERRMSK=0 */
  CAN0_CTRL1 &= (uint32_t)~(uint32_t)(
                 CAN_CTRL1_BOFFMSK_MASK |
                 CAN_CTRL1_ERRMSK_MASK
                );
  /* CAN0_IMASK1: BUFLM&=~0xFFFF */
  CAN0_IMASK1 &= (uint32_t)~(uint32_t)(CAN_IMASK1_BUFLM(0xFFFF));
  /* CAN0_MCR: MDIS=0,FRZ=1,HALT=1,MAXMB=0x0F */
  CAN0_MCR = (uint32_t)((CAN0_MCR & (uint32_t)~(uint32_t)(
              CAN_MCR_MDIS_MASK |
              CAN_MCR_MAXMB(0x70)
             )) | (uint32_t)(
              CAN_MCR_FRZ_MASK |
              CAN_MCR_HALT_MASK |
              CAN_MCR_MAXMB(0x0F)
             ));
}

/*
** ###################################################################
**
**  The interrupt service routine(s) must be implemented
**  by user in one of the following user modules.
**
**  If the "Generate ISR" option is enabled, Processor Expert generates
**  ISR templates in the CPU event module.
**
**  User modules:
**      ProcessorExpert.c
**      Events.c
**
** ###################################################################
PE_ISR(CAN1_PowerTxDone_Int)
{
// NOTE: The routine should include actions to clear the appropriate
//       interrupt flags.
//
}
*/


/* END CAN1. */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
